Add git send-email to the chroot
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         test/autotools \
107         lib \
108         lib/build \
109         lib/client \
110         lib/cmdlib \
111         lib/confd \
112         lib/http \
113         lib/hypervisor \
114         lib/impexpd \
115         lib/masterd \
116         lib/rapi \
117         lib/server \
118         lib/tools \
119         lib/utils \
120         lib/watcher \
121         man \
122         qa \
123         test \
124         test/data \
125         test/data/bdev-rbd \
126         test/data/ovfdata \
127         test/data/ovfdata/other \
128         test/py \
129         tools
130
131 ALL_APIDOC_HS_DIRS = \
132         $(APIDOC_HS_DIR) \
133         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
134
135 BUILDTIME_DIR_AUTOCREATE = \
136         scripts \
137         $(APIDOC_DIR) \
138         $(ALL_APIDOC_HS_DIRS) \
139         $(APIDOC_PY_DIR) \
140         $(COVERAGE_DIR) \
141         $(COVERAGE_HS_DIR) \
142         $(COVERAGE_PY_DIR) \
143         .hpc
144
145 BUILDTIME_DIRS = \
146         $(BUILDTIME_DIR_AUTOCREATE) \
147         doc/html \
148         doc/man-html
149
150 DIRCHECK_EXCLUDE = \
151         $(BUILDTIME_DIRS) \
152         ganeti-[0-9]*.[0-9]*.[0-9]* \
153         doc/html/_* \
154         doc/man-html/_* \
155         autom4te.cache
156
157 # some helper vars
158 COVERAGE_DIR = doc/coverage
159 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
160 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
161 APIDOC_DIR = doc/api
162 APIDOC_PY_DIR = $(APIDOC_DIR)/py
163 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
164
165 MAINTAINERCLEANFILES = \
166         $(maninput) \
167         doc/install-quick.rst \
168         doc/news.rst \
169         doc/upgrade.rst \
170         vcs-version
171
172 maintainer-clean-local:
173         rm -rf $(BUILDTIME_DIRS)
174
175 CLEANFILES = \
176         $(addsuffix /*.py[co],$(DIRS)) \
177         $(addsuffix /*.hi,$(HS_DIRS)) \
178         $(addsuffix /*.o,$(HS_DIRS)) \
179         $(PYTHON_BOOTSTRAP) \
180         epydoc.conf \
181         $(REPLACE_VARS_SED) \
182         $(SHELL_ENV_INIT) \
183         daemons/daemon-util \
184         daemons/ganeti-cleaner \
185         devel/squeeze-amd64.tar.gz \
186         devel/squeeze-amd64.conf \
187         $(mandocrst) \
188         doc/manpages-enabled.rst \
189         $(BUILT_EXAMPLES) \
190         doc/examples/bash_completion \
191         doc/examples/bash_completion-debug \
192         lib/_generated_rpc.py \
193         $(man_MANS) \
194         $(manhtml) \
195         tools/kvm-ifup \
196         tools/users-setup \
197         tools/vcluster-setup \
198         stamp-directories \
199         stamp-srclinks \
200         $(nodist_pkgpython_PYTHON) \
201         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
202         $(HS_BUILT_TEST_HELPERS) \
203         src/ganeti-confd \
204         src/ganeti-mond \
205         .hpc/*.mix src/*.tix test/hs/*.tix \
206         doc/hs-lint.html
207
208 GENERATED_FILES = \
209         $(built_base_sources) \
210         $(BUILT_PYTHON_SOURCES) \
211         $(PYTHON_BOOTSTRAP)
212
213 HS_GENERATED_FILES =
214 if WANT_HTOOLS
215 HS_GENERATED_FILES += $(HS_PROGS)
216 if ENABLE_CONFD
217 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
218 endif
219
220 if ENABLE_MOND
221 HS_GENERATED_FILES += src/ganeti-mond
222 endif
223 endif
224
225 built_base_sources = \
226         stamp-directories \
227         stamp-srclinks
228
229 built_python_base_sources = \
230         lib/_autoconf.py \
231         lib/_vcsversion.py
232
233 BUILT_PYTHON_SOURCES = \
234         $(built_python_base_sources) \
235         lib/_generated_rpc.py
236
237 # Generating the RPC wrappers depends on many things, so make sure
238 # it's built at the end of the built sources
239 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
240
241 # these are all built from the underlying %.in sources
242 BUILT_EXAMPLES = \
243         doc/examples/ganeti-kvm-poweroff.initd \
244         doc/examples/ganeti.cron \
245         doc/examples/ganeti.initd \
246         doc/examples/ganeti-master-role.ocf \
247         doc/examples/ganeti-node-role.ocf \
248         doc/examples/gnt-config-backup \
249         doc/examples/hooks/ipsec
250
251 nodist_pkgpython_PYTHON = \
252         $(BUILT_PYTHON_SOURCES)
253
254 noinst_PYTHON = \
255         lib/build/__init__.py \
256         lib/build/shell_example_lexer.py \
257         lib/build/sphinx_ext.py
258
259 pkgpython_PYTHON = \
260         lib/__init__.py \
261         lib/asyncnotifier.py \
262         lib/backend.py \
263         lib/bdev.py \
264         lib/bootstrap.py \
265         lib/cli.py \
266         lib/compat.py \
267         lib/config.py \
268         lib/constants.py \
269         lib/daemon.py \
270         lib/errors.py \
271         lib/hooksmaster.py \
272         lib/ht.py \
273         lib/jqueue.py \
274         lib/jstore.py \
275         lib/locking.py \
276         lib/luxi.py \
277         lib/mcpu.py \
278         lib/netutils.py \
279         lib/objects.py \
280         lib/opcodes.py \
281         lib/outils.py \
282         lib/ovf.py \
283         lib/pathutils.py \
284         lib/qlang.py \
285         lib/query.py \
286         lib/rpc.py \
287         lib/rpc_defs.py \
288         lib/runtime.py \
289         lib/serializer.py \
290         lib/ssconf.py \
291         lib/ssh.py \
292         lib/storage.py \
293         lib/uidpool.py \
294         lib/vcluster.py \
295         lib/network.py \
296         lib/workerpool.py
297
298 client_PYTHON = \
299         lib/client/__init__.py \
300         lib/client/gnt_backup.py \
301         lib/client/gnt_cluster.py \
302         lib/client/gnt_debug.py \
303         lib/client/gnt_group.py \
304         lib/client/gnt_instance.py \
305         lib/client/gnt_job.py \
306         lib/client/gnt_node.py \
307         lib/client/gnt_network.py \
308         lib/client/gnt_os.py \
309         lib/client/gnt_storage.py
310
311 cmdlib_PYTHON = \
312         lib/cmdlib/__init__.py \
313         lib/cmdlib/backup.py \
314         lib/cmdlib/base.py \
315         lib/cmdlib/cluster.py \
316         lib/cmdlib/common.py \
317         lib/cmdlib/group.py \
318         lib/cmdlib/instance.py \
319         lib/cmdlib/instance_migration.py \
320         lib/cmdlib/instance_operation.py \
321         lib/cmdlib/instance_query.py \
322         lib/cmdlib/instance_storage.py \
323         lib/cmdlib/instance_utils.py \
324         lib/cmdlib/misc.py \
325         lib/cmdlib/network.py \
326         lib/cmdlib/node.py \
327         lib/cmdlib/operating_system.py \
328         lib/cmdlib/query.py \
329         lib/cmdlib/tags.py \
330         lib/cmdlib/test.py
331
332 hypervisor_PYTHON = \
333         lib/hypervisor/__init__.py \
334         lib/hypervisor/hv_base.py \
335         lib/hypervisor/hv_chroot.py \
336         lib/hypervisor/hv_fake.py \
337         lib/hypervisor/hv_kvm.py \
338         lib/hypervisor/hv_lxc.py \
339         lib/hypervisor/hv_xen.py
340
341 rapi_PYTHON = \
342         lib/rapi/__init__.py \
343         lib/rapi/baserlib.py \
344         lib/rapi/client.py \
345         lib/rapi/client_utils.py \
346         lib/rapi/connector.py \
347         lib/rapi/rlib2.py \
348         lib/rapi/testutils.py
349
350 http_PYTHON = \
351         lib/http/__init__.py \
352         lib/http/auth.py \
353         lib/http/client.py \
354         lib/http/server.py
355
356 confd_PYTHON = \
357         lib/confd/__init__.py \
358         lib/confd/client.py
359
360 masterd_PYTHON = \
361         lib/masterd/__init__.py \
362         lib/masterd/iallocator.py \
363         lib/masterd/instance.py
364
365 impexpd_PYTHON = \
366         lib/impexpd/__init__.py
367
368 watcher_PYTHON = \
369         lib/watcher/__init__.py \
370         lib/watcher/nodemaint.py \
371         lib/watcher/state.py
372
373 server_PYTHON = \
374         lib/server/__init__.py \
375         lib/server/masterd.py \
376         lib/server/noded.py \
377         lib/server/rapi.py
378
379 pytools_PYTHON = \
380         lib/tools/__init__.py \
381         lib/tools/burnin.py \
382         lib/tools/ensure_dirs.py \
383         lib/tools/node_cleanup.py \
384         lib/tools/node_daemon_setup.py \
385         lib/tools/prepare_node_join.py
386
387 utils_PYTHON = \
388         lib/utils/__init__.py \
389         lib/utils/algo.py \
390         lib/utils/filelock.py \
391         lib/utils/hash.py \
392         lib/utils/io.py \
393         lib/utils/log.py \
394         lib/utils/lvm.py \
395         lib/utils/mlock.py \
396         lib/utils/nodesetup.py \
397         lib/utils/process.py \
398         lib/utils/retry.py \
399         lib/utils/text.py \
400         lib/utils/wrapper.py \
401         lib/utils/x509.py
402
403 docinput = \
404         doc/conf.py \
405         doc/css/style.css \
406         doc/admin.rst \
407         doc/cluster-merge.rst \
408         doc/design-2.0.rst \
409         doc/design-2.1.rst \
410         doc/design-2.2.rst \
411         doc/design-2.3.rst \
412         doc/design-2.4.rst \
413         doc/design-2.5.rst \
414         doc/design-2.6.rst \
415         doc/design-2.7.rst \
416         doc/design-2.8.rst \
417         doc/design-autorepair.rst \
418         doc/design-bulk-create.rst \
419         doc/design-chained-jobs.rst \
420         doc/design-cpu-pinning.rst \
421         doc/design-device-uuid-name.rst \
422         doc/design-draft.rst \
423         doc/design-htools-2.3.rst \
424         doc/design-http-server.rst \
425         doc/design-impexp2.rst \
426         doc/design-lu-generated-jobs.rst \
427         doc/design-linuxha.rst \
428         doc/design-multi-reloc.rst \
429         doc/design-network.rst \
430         doc/design-node-add.rst \
431         doc/design-oob.rst \
432         doc/design-ovf-support.rst \
433         doc/design-opportunistic-locking.rst \
434         doc/design-partitioned.rst \
435         doc/design-query-splitting.rst \
436         doc/design-query2.rst \
437         doc/design-reason-trail.rst \
438         doc/design-resource-model.rst \
439         doc/design-restricted-commands.rst \
440         doc/design-shared-storage.rst \
441         doc/design-monitoring-agent.rst \
442         doc/design-virtual-clusters.rst \
443         doc/design-x509-ca.rst \
444         doc/design-hroller.rst \
445         doc/design-storagetypes.rst \
446         doc/devnotes.rst \
447         doc/glossary.rst \
448         doc/hooks.rst \
449         doc/iallocator.rst \
450         doc/index.rst \
451         doc/install-quick.rst \
452         doc/install.rst \
453         doc/locking.rst \
454         doc/manpages-disabled.rst \
455         doc/move-instance.rst \
456         doc/news.rst \
457         doc/ovfconverter.rst \
458         doc/rapi.rst \
459         doc/security.rst \
460         doc/upgrade.rst \
461         doc/virtual-cluster.rst \
462         doc/walkthrough.rst
463
464 # Generates file names such as "doc/man-gnt-instance.rst"
465 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
466
467 # Haskell programs to be installed in $PREFIX/bin
468 HS_BIN_PROGS=src/htools
469
470 # Haskell programs to be installed in the MYEXECLIB dir
471 if ENABLE_MOND
472 HS_MYEXECLIB_PROGS=src/mon-collector
473 else
474 HS_MYEXECLIB_PROGS=
475 endif
476
477 # Haskell programs to be compiled by "make really-all"
478 HS_COMPILE_PROGS= \
479         src/ganeti-mond \
480         src/hconfd \
481         src/rpc-test
482
483 # All Haskell non-test programs to be compiled but not automatically installed
484 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
485
486 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
487 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
488
489 HS_ALL_PROGS = \
490         $(HS_PROGS) \
491         test/hs/hpc-htools \
492         test/hs/hpc-mon-collector \
493         test/hs/htest \
494         $(HS_COMPILE_PROGS)
495
496 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
497 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
498
499 HFLAGS = \
500         -O -Wall -Werror -isrc \
501         -fwarn-monomorphism-restriction \
502         -fwarn-tabs \
503         $(GHC_BYVERSION_FLAGS)
504
505 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
506 HEXTRA =
507 # internal extra flags (used for test/hs/htest mainly)
508 HEXTRA_INT =
509 # exclude options for coverage reports
510 HPCEXCL = --exclude Main \
511         --exclude Ganeti.Constants \
512         --exclude Ganeti.HTools.QC \
513         --exclude Ganeti.THH \
514         --exclude Ganeti.Version \
515         --exclude Test.Ganeti.Attoparsec \
516         --exclude Test.Ganeti.TestCommon \
517         --exclude Test.Ganeti.TestHTools \
518         --exclude Test.Ganeti.TestHelper \
519         --exclude Test.Ganeti.TestImports \
520         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
521
522 HS_LIB_SRCS = \
523         src/Ganeti/Block/Drbd/Types.hs \
524         src/Ganeti/Block/Drbd/Parser.hs \
525         src/Ganeti/BasicTypes.hs \
526         src/Ganeti/Common.hs \
527         src/Ganeti/Compat.hs \
528         src/Ganeti/Confd/Client.hs \
529         src/Ganeti/Confd/Server.hs \
530         src/Ganeti/Confd/Types.hs \
531         src/Ganeti/Confd/Utils.hs \
532         src/Ganeti/Config.hs \
533         src/Ganeti/Curl/Multi.hs \
534         src/Ganeti/Daemon.hs \
535         src/Ganeti/DataCollectors/CLI.hs \
536         src/Ganeti/DataCollectors/Drbd.hs \
537         src/Ganeti/DataCollectors/Program.hs \
538         src/Ganeti/DataCollectors/Types.hs \
539         src/Ganeti/Errors.hs \
540         src/Ganeti/HTools/Backend/IAlloc.hs \
541         src/Ganeti/HTools/Backend/Luxi.hs \
542         src/Ganeti/HTools/Backend/Rapi.hs \
543         src/Ganeti/HTools/Backend/Simu.hs \
544         src/Ganeti/HTools/Backend/Text.hs \
545         src/Ganeti/HTools/CLI.hs \
546         src/Ganeti/HTools/Cluster.hs \
547         src/Ganeti/HTools/Container.hs \
548         src/Ganeti/HTools/ExtLoader.hs \
549         src/Ganeti/HTools/Graph.hs \
550         src/Ganeti/HTools/Group.hs \
551         src/Ganeti/HTools/Instance.hs \
552         src/Ganeti/HTools/Loader.hs \
553         src/Ganeti/HTools/Nic.hs \
554         src/Ganeti/HTools/Node.hs \
555         src/Ganeti/HTools/PeerMap.hs \
556         src/Ganeti/HTools/Program/Hail.hs \
557         src/Ganeti/HTools/Program/Harep.hs \
558         src/Ganeti/HTools/Program/Hbal.hs \
559         src/Ganeti/HTools/Program/Hcheck.hs \
560         src/Ganeti/HTools/Program/Hinfo.hs \
561         src/Ganeti/HTools/Program/Hscan.hs \
562         src/Ganeti/HTools/Program/Hspace.hs \
563         src/Ganeti/HTools/Program/Hroller.hs \
564         src/Ganeti/HTools/Program/Main.hs \
565         src/Ganeti/HTools/Types.hs \
566         src/Ganeti/Hypervisor/Xen/XmParser.hs \
567         src/Ganeti/Hypervisor/Xen/Types.hs \
568         src/Ganeti/Hash.hs \
569         src/Ganeti/JQueue.hs \
570         src/Ganeti/JSON.hs \
571         src/Ganeti/Jobs.hs \
572         src/Ganeti/Logging.hs \
573         src/Ganeti/Luxi.hs \
574         src/Ganeti/Monitoring/Server.hs \
575         src/Ganeti/Network.hs \
576         src/Ganeti/Objects.hs \
577         src/Ganeti/OpCodes.hs \
578         src/Ganeti/OpParams.hs \
579         src/Ganeti/Path.hs \
580         src/Ganeti/Query/Common.hs \
581         src/Ganeti/Query/Export.hs \
582         src/Ganeti/Query/Filter.hs \
583         src/Ganeti/Query/Group.hs \
584         src/Ganeti/Query/Job.hs \
585         src/Ganeti/Query/Language.hs \
586         src/Ganeti/Query/Network.hs \
587         src/Ganeti/Query/Node.hs \
588         src/Ganeti/Query/Query.hs \
589         src/Ganeti/Query/Server.hs \
590         src/Ganeti/Query/Types.hs \
591         src/Ganeti/Rpc.hs \
592         src/Ganeti/Runtime.hs \
593         src/Ganeti/Ssconf.hs \
594         src/Ganeti/THH.hs \
595         src/Ganeti/Types.hs \
596         src/Ganeti/Utils.hs
597
598 HS_TEST_SRCS = \
599         test/hs/Test/Ganeti/Attoparsec.hs \
600         test/hs/Test/Ganeti/BasicTypes.hs \
601         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
602         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
603         test/hs/Test/Ganeti/Common.hs \
604         test/hs/Test/Ganeti/Confd/Types.hs \
605         test/hs/Test/Ganeti/Confd/Utils.hs \
606         test/hs/Test/Ganeti/Daemon.hs \
607         test/hs/Test/Ganeti/Errors.hs \
608         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
609         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
610         test/hs/Test/Ganeti/HTools/CLI.hs \
611         test/hs/Test/Ganeti/HTools/Cluster.hs \
612         test/hs/Test/Ganeti/HTools/Container.hs \
613         test/hs/Test/Ganeti/HTools/Graph.hs \
614         test/hs/Test/Ganeti/HTools/Instance.hs \
615         test/hs/Test/Ganeti/HTools/Loader.hs \
616         test/hs/Test/Ganeti/HTools/Node.hs \
617         test/hs/Test/Ganeti/HTools/PeerMap.hs \
618         test/hs/Test/Ganeti/HTools/Types.hs \
619         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
620         test/hs/Test/Ganeti/JSON.hs \
621         test/hs/Test/Ganeti/Jobs.hs \
622         test/hs/Test/Ganeti/JQueue.hs \
623         test/hs/Test/Ganeti/Luxi.hs \
624         test/hs/Test/Ganeti/Network.hs \
625         test/hs/Test/Ganeti/Objects.hs \
626         test/hs/Test/Ganeti/OpCodes.hs \
627         test/hs/Test/Ganeti/Query/Filter.hs \
628         test/hs/Test/Ganeti/Query/Language.hs \
629         test/hs/Test/Ganeti/Query/Network.hs \
630         test/hs/Test/Ganeti/Query/Query.hs \
631         test/hs/Test/Ganeti/Rpc.hs \
632         test/hs/Test/Ganeti/Runtime.hs \
633         test/hs/Test/Ganeti/Ssconf.hs \
634         test/hs/Test/Ganeti/THH.hs \
635         test/hs/Test/Ganeti/TestCommon.hs \
636         test/hs/Test/Ganeti/TestHTools.hs \
637         test/hs/Test/Ganeti/TestHelper.hs \
638         test/hs/Test/Ganeti/Types.hs \
639         test/hs/Test/Ganeti/Utils.hs
640
641 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
642
643 HS_BUILT_SRCS = \
644         test/hs/Test/Ganeti/TestImports.hs \
645         src/Ganeti/Constants.hs \
646         src/Ganeti/Curl/Internal.hs \
647         src/Ganeti/Version.hs
648 HS_BUILT_SRCS_IN = \
649         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
650         src/Ganeti/Curl/Internal.hsc
651
652 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
653
654 $(RUN_IN_TEMPDIR): | stamp-directories
655
656 doc/html/index.html: ENABLE_MANPAGES =
657 doc/man-html/index.html: ENABLE_MANPAGES = 1
658 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
659
660 # Note: we use here an order-only prerequisite, as the contents of
661 # _autoconf.py are not actually influencing the html build output: it
662 # has to exist in order for the sphinx module to be loaded
663 # successfully, but we certainly don't want the docs to be rebuilt if
664 # it changes
665 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
666         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
667         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
668         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
669         | $(BUILT_PYTHON_SOURCES)
670         @test -n "$(SPHINX)" || \
671             { echo 'sphinx-build' not found during configure; exit 1; }
672 if !MANPAGES_IN_DOC
673         if test -n '$(ENABLE_MANPAGES)'; then \
674           echo 'Man pages in documentation were disabled at configure time' >&2; \
675           exit 1; \
676         fi
677 endif
678 ## Sphinx provides little control over what content should be included. Some
679 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
680 ## build two different versions of the documentation--once without man pages and
681 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
682 ## us with this, but requires running in a temporary directory. It moves the
683 ## correct files into place depending on environment variables.
684         dir=$(dir $@) && \
685         @mkdir_p@ $$dir && \
686         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
687         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
688             -d . \
689             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
690             -D release="$(PACKAGE_VERSION)" \
691             -D graphviz_dot="$(DOT)" \
692             -D enable_manpages="$(ENABLE_MANPAGES)" \
693             doc $(CURDIR)/$$dir && \
694         rm -f $$dir/.buildinfo $$dir/objects.inv
695         touch $@
696
697 doc/html: doc/html/index.html
698
699 doc/man-html: doc/man-html/index.html
700
701 doc/install-quick.rst: INSTALL
702 doc/news.rst: NEWS
703 doc/upgrade.rst: UPGRADE
704
705 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
706         set -e; \
707         { echo '.. This file is automatically updated at build time from $<.'; \
708           echo '.. Do not edit.'; \
709           echo; \
710           cat $<; \
711         } > $@
712
713 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
714         { echo '.. This file is automatically generated, do not edit!'; \
715           echo ''; \
716           echo 'Man pages'; \
717           echo '========='; \
718           echo; \
719           echo '.. toctree::'; \
720           echo '   :maxdepth: 1'; \
721           echo; \
722           for i in $(notdir $(mandocrst)); do \
723             echo "   $$i"; \
724           done | LC_ALL=C sort; \
725         } > $@
726
727 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
728 if MANPAGES_IN_DOC
729         { echo '.. This file is automatically updated at build time from $<.'; \
730           echo '.. Do not edit.'; \
731           echo; \
732           echo "$*"; \
733           echo '=========================================='; \
734           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
735         } > $@
736 else
737         echo 'Man pages in documentation were disabled at configure time' >&2; \
738         exit 1;
739 endif
740
741 # Things to build but not to install (add it to EXTRA_DIST if it should be
742 # distributed)
743 noinst_DATA = \
744         doc/html \
745         $(BUILT_EXAMPLES) \
746         doc/examples/bash_completion \
747         doc/examples/bash_completion-debug \
748         $(manhtml)
749
750 if MANPAGES_IN_DOC
751 noinst_DATA += doc/man-html
752 endif
753
754 gnt_scripts = \
755         scripts/gnt-backup \
756         scripts/gnt-cluster \
757         scripts/gnt-debug \
758         scripts/gnt-group \
759         scripts/gnt-instance \
760         scripts/gnt-job \
761         scripts/gnt-network \
762         scripts/gnt-node \
763         scripts/gnt-os \
764         scripts/gnt-storage
765
766 PYTHON_BOOTSTRAP_SBIN = \
767         daemons/ganeti-masterd \
768         daemons/ganeti-noded \
769         daemons/ganeti-rapi \
770         daemons/ganeti-watcher \
771         $(gnt_scripts)
772
773 PYTHON_BOOTSTRAP = \
774         $(PYTHON_BOOTSTRAP_SBIN) \
775         tools/burnin \
776         tools/ensure-dirs \
777         tools/node-cleanup \
778         tools/node-daemon-setup \
779         tools/prepare-node-join
780
781 qa_scripts = \
782         qa/__init__.py \
783         qa/ganeti-qa.py \
784         qa/qa_cluster.py \
785         qa/qa_config.py \
786         qa/qa_daemon.py \
787         qa/qa_env.py \
788         qa/qa_error.py \
789         qa/qa_group.py \
790         qa/qa_instance.py \
791         qa/qa_job.py \
792         qa/qa_node.py \
793         qa/qa_os.py \
794         qa/qa_rapi.py \
795         qa/qa_tags.py \
796         qa/qa_utils.py
797
798 bin_SCRIPTS =
799 if WANT_HTOOLS
800 bin_SCRIPTS += $(HS_BIN_PROGS)
801 install-exec-hook:
802         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
803 # FIXME: this is a hardcoded logic, instead of auto-resolving
804         $(LN_S) -f ../../../bin/htools \
805           $(DESTDIR)$(iallocatorsdir)/hail
806         for role in $(HS_BIN_ROLES); do \
807           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
808         done
809 endif
810
811 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
812         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
813           echo "Error: cannot run unittests without the development" \
814                " libraries (see devnotes.rst)" 1>&2; \
815           exit 1; \
816         fi
817         @rm -f $(notdir $@).tix
818         $(GHC) --make \
819           $(HFLAGS) \
820           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
821           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
822           $(HEXTRA) $(HEXTRA_INT) $@
823         @touch "$@"
824
825 # for the test/hs/htest binary, we need to enable profiling/coverage
826 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
827
828 # we compile the hpc-htools binary with the program coverage
829 test/hs/hpc-htools: HEXTRA_INT=-fhpc
830
831 # we compile the hpc-mon-collector binary with the program coverage
832 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
833
834 # test dependency
835 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
836
837 # rules for building profiling-enabled versions of the haskell
838 # programs: hs-prof does the full two-step build, whereas
839 # hs-prof-quick does only the final rebuild (hs-prof must have been
840 # run before)
841 .PHONY: hs-prof hs-prof-quick
842 hs-prof:
843         @if [ -z "$(TARGET)" ]; then \
844           echo "You need to define TARGET when running this rule" 1>&2; \
845           exit 1; \
846         fi
847         $(MAKE) $(AM_MAKEFLAGS) clean
848         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
849         rm -f $(HS_ALL_PROGS)
850         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
851
852 hs-prof-quick:
853         @if [ -z "$(TARGET)" ]; then \
854           echo "You need to define TARGET when running this rule" 1>&2; \
855           exit 1; \
856         fi
857         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
858
859 dist_sbin_SCRIPTS = \
860         tools/ganeti-listrunner
861
862 nodist_sbin_SCRIPTS = \
863         $(PYTHON_BOOTSTRAP_SBIN) \
864         daemons/ganeti-cleaner
865
866 if ENABLE_CONFD
867 src/ganeti-confd: src/hconfd
868         cp -f $< $@
869
870 nodist_sbin_SCRIPTS += src/ganeti-confd
871 endif
872
873 if ENABLE_MOND
874 nodist_sbin_SCRIPTS += src/ganeti-mond
875 endif
876
877 python_scripts = \
878         tools/cfgshell \
879         tools/cfgupgrade \
880         tools/cfgupgrade12 \
881         tools/cluster-merge \
882         tools/confd-client \
883         tools/fmtjson \
884         tools/lvmstrap \
885         tools/move-instance \
886         tools/ovfconverter \
887         tools/sanitize-config
888
889 dist_tools_SCRIPTS = \
890         $(python_scripts) \
891         tools/burnin \
892         tools/kvm-console-wrapper \
893         tools/master-ip-setup \
894         tools/xen-console-wrapper
895
896 nodist_tools_python_scripts = \
897         tools/node-cleanup
898
899 nodist_tools_SCRIPTS = \
900         $(nodist_tools_python_scripts) \
901         tools/users-setup \
902         tools/vcluster-setup
903
904 pkglib_python_scripts = \
905         daemons/import-export \
906         tools/check-cert-expired
907
908 nodist_pkglib_python_scripts = \
909         tools/ensure-dirs \
910         tools/node-daemon-setup \
911         tools/prepare-node-join
912
913 myexeclib_SCRIPTS = \
914         daemons/daemon-util \
915         tools/kvm-ifup \
916         $(pkglib_python_scripts) \
917         $(HS_MYEXECLIB_PROGS)
918
919 nodist_myexeclib_SCRIPTS = \
920         $(nodist_pkglib_python_scripts)
921
922 EXTRA_DIST = \
923         NEWS \
924         UPGRADE \
925         epydoc.conf.in \
926         pylintrc \
927         autotools/build-bash-completion \
928         autotools/build-rpc \
929         autotools/check-header \
930         autotools/check-imports \
931         autotools/check-man-dashes \
932         autotools/check-man-references \
933         autotools/check-man-warnings \
934         autotools/check-news \
935         autotools/check-python-code \
936         autotools/check-tar \
937         autotools/check-version \
938         autotools/convert-constants \
939         autotools/docpp \
940         autotools/gen-py-coverage \
941         autotools/sphinx-wrapper \
942         autotools/testrunner \
943         autotools/wrong-hardcoded-paths \
944         $(RUN_IN_TEMPDIR) \
945         daemons/daemon-util.in \
946         daemons/ganeti-cleaner.in \
947         $(pkglib_python_scripts) \
948         devel/upload \
949         devel/webserver \
950         tools/kvm-ifup.in \
951         tools/users-setup.in \
952         tools/vcluster-setup.in \
953         $(docinput) \
954         doc/html \
955         $(BUILT_EXAMPLES:%=%.in) \
956         doc/examples/ganeti.default \
957         doc/examples/ganeti.default-debug \
958         doc/examples/hooks/ethers \
959         doc/examples/gnt-debug/README \
960         doc/examples/gnt-debug/delay0.json \
961         doc/examples/gnt-debug/delay50.json \
962         test/py/lockperf.py \
963         test/py/testutils.py \
964         test/py/mocks.py \
965         $(dist_TESTS) \
966         $(TEST_FILES) \
967         man/footer.rst \
968         $(manrst) \
969         $(maninput) \
970         qa/qa-sample.json \
971         $(qa_scripts) \
972         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
973         $(HS_PROG_SRCS) \
974         src/lint-hints.hs \
975         test/hs/cli-tests-defs.sh \
976         test/hs/offline-test.sh \
977         .ghci
978
979 man_MANS = \
980         man/ganeti-cleaner.8 \
981         man/ganeti-confd.8 \
982         man/ganeti-listrunner.8 \
983         man/ganeti-masterd.8 \
984         man/ganeti-mond.8 \
985         man/ganeti-noded.8 \
986         man/ganeti-os-interface.7 \
987         man/ganeti-extstorage-interface.7 \
988         man/ganeti-rapi.8 \
989         man/ganeti-watcher.8 \
990         man/ganeti.7 \
991         man/gnt-backup.8 \
992         man/gnt-cluster.8 \
993         man/gnt-debug.8 \
994         man/gnt-group.8 \
995         man/gnt-network.8 \
996         man/gnt-instance.8 \
997         man/gnt-job.8 \
998         man/gnt-node.8 \
999         man/gnt-os.8 \
1000         man/gnt-storage.8 \
1001         man/hail.1 \
1002         man/harep.1 \
1003         man/hbal.1 \
1004         man/hcheck.1 \
1005         man/hinfo.1 \
1006         man/hscan.1 \
1007         man/hspace.1 \
1008         man/hroller.1 \
1009         man/htools.1 \
1010         man/mon-collector.7
1011
1012 # Remove extensions from all filenames in man_MANS
1013 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1014
1015 manrst = $(patsubst %,%.rst,$(mannoext))
1016 manhtml = $(patsubst %.rst,%.html,$(manrst))
1017 mangen = $(patsubst %.rst,%.gen,$(manrst))
1018 maninput = \
1019         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1020         $(patsubst %.html,%.html.in,$(manhtml)) \
1021         $(mangen)
1022
1023 TEST_FILES = \
1024         test/autotools/autotools-check-news.test \
1025         test/data/htools/clean-nonzero-score.data \
1026         test/data/htools/common-suffix.data \
1027         test/data/htools/empty-cluster.data \
1028         test/data/htools/hail-alloc-drbd.json \
1029         test/data/htools/hail-alloc-invalid-network.json \
1030         test/data/htools/hail-alloc-invalid-twodisks.json \
1031         test/data/htools/hail-alloc-restricted-network.json \
1032         test/data/htools/hail-alloc-twodisks.json \
1033         test/data/htools/hail-change-group.json \
1034         test/data/htools/hail-invalid-reloc.json \
1035         test/data/htools/hail-node-evac.json \
1036         test/data/htools/hail-reloc-drbd.json \
1037         test/data/htools/hbal-excl-tags.data \
1038         test/data/htools/hbal-split-insts.data \
1039         test/data/htools/hspace-tiered-dualspec.data \
1040         test/data/htools/hspace-tiered-ipolicy.data \
1041         test/data/htools/hspace-tiered-resourcetypes.data \
1042         test/data/htools/hspace-tiered.data \
1043         test/data/htools/invalid-node.data \
1044         test/data/htools/missing-resources.data \
1045         test/data/htools/multiple-master.data \
1046         test/data/htools/n1-failure.data \
1047         test/data/htools/rapi/groups.json \
1048         test/data/htools/rapi/info.json \
1049         test/data/htools/rapi/instances.json \
1050         test/data/htools/rapi/nodes.json \
1051         test/data/htools/unique-reboot-order.data \
1052         test/hs/shelltests/htools-balancing.test \
1053         test/hs/shelltests/htools-basic.test \
1054         test/hs/shelltests/htools-dynutil.test \
1055         test/hs/shelltests/htools-excl.test \
1056         test/hs/shelltests/htools-hail.test \
1057         test/hs/shelltests/htools-hroller.test \
1058         test/hs/shelltests/htools-hspace.test \
1059         test/hs/shelltests/htools-invalid.test \
1060         test/hs/shelltests/htools-multi-group.test \
1061         test/hs/shelltests/htools-no-backend.test \
1062         test/hs/shelltests/htools-rapi.test \
1063         test/hs/shelltests/htools-single-group.test \
1064         test/hs/shelltests/htools-text-backend.test \
1065         test/hs/shelltests/htools-mon-collector.test \
1066         test/data/bdev-drbd-8.0.txt \
1067         test/data/bdev-drbd-8.3.txt \
1068         test/data/bdev-drbd-disk.txt \
1069         test/data/bdev-drbd-net-ip4.txt \
1070         test/data/bdev-drbd-net-ip6.txt \
1071         test/data/bdev-rbd/json_output_empty.txt \
1072         test/data/bdev-rbd/json_output_extra_matches.txt \
1073         test/data/bdev-rbd/json_output_no_matches.txt \
1074         test/data/bdev-rbd/json_output_ok.txt \
1075         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1076         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1077         test/data/bdev-rbd/plain_output_new_ok.txt \
1078         test/data/bdev-rbd/plain_output_old_empty.txt \
1079         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1080         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1081         test/data/bdev-rbd/plain_output_old_ok.txt \
1082         test/data/bdev-rbd/output_invalid.txt \
1083         test/data/cert1.pem \
1084         test/data/cert2.pem \
1085         test/data/cluster_config_2.7.json \
1086         test/data/cluster_config_downgraded_2.7.json \
1087         test/data/instance-minor-pairing.txt \
1088         test/data/ip-addr-show-dummy0.txt \
1089         test/data/ip-addr-show-lo-ipv4.txt \
1090         test/data/ip-addr-show-lo-ipv6.txt \
1091         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1092         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1093         test/data/ip-addr-show-lo-oneline.txt \
1094         test/data/ip-addr-show-lo.txt \
1095         test/data/kvm_0.12.5_help.txt \
1096         test/data/kvm_0.15.90_help.txt \
1097         test/data/kvm_0.9.1_help.txt \
1098         test/data/kvm_0.9.1_help_boot_test.txt \
1099         test/data/kvm_1.0_help.txt \
1100         test/data/kvm_1.1.2_help.txt \
1101         test/data/NEWS_OK.txt \
1102         test/data/NEWS_previous_unreleased.txt \
1103         test/data/ovfdata/compr_disk.vmdk.gz \
1104         test/data/ovfdata/config.ini \
1105         test/data/ovfdata/corrupted_resources.ovf \
1106         test/data/ovfdata/empty.ini \
1107         test/data/ovfdata/empty.ovf \
1108         test/data/ovfdata/ganeti.mf \
1109         test/data/ovfdata/ganeti.ovf \
1110         test/data/ovfdata/gzip_disk.ovf \
1111         test/data/ovfdata/new_disk.vmdk \
1112         test/data/ovfdata/no_disk.ini \
1113         test/data/ovfdata/no_disk_in_ref.ovf \
1114         test/data/ovfdata/no_os.ini \
1115         test/data/ovfdata/no_ovf.ova \
1116         test/data/ovfdata/other/rawdisk.raw \
1117         test/data/ovfdata/ova.ova \
1118         test/data/ovfdata/rawdisk.raw \
1119         test/data/ovfdata/second_disk.vmdk \
1120         test/data/ovfdata/unsafe_path.ini \
1121         test/data/ovfdata/virtualbox.ovf \
1122         test/data/ovfdata/wrong_config.ini \
1123         test/data/ovfdata/wrong_extension.ovd \
1124         test/data/ovfdata/wrong_manifest.mf \
1125         test/data/ovfdata/wrong_manifest.ovf \
1126         test/data/ovfdata/wrong_ova.ova \
1127         test/data/ovfdata/wrong_xml.ovf \
1128         test/data/proc_drbd8.txt \
1129         test/data/proc_drbd80-emptyline.txt \
1130         test/data/proc_drbd83.txt \
1131         test/data/proc_drbd83_sync.txt \
1132         test/data/proc_drbd83_sync_want.txt \
1133         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1134         test/data/qa-minimal-nodes-instances-only.json \
1135         test/data/sys_drbd_usermode_helper.txt \
1136         test/data/vgreduce-removemissing-2.02.02.txt \
1137         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1138         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1139         test/data/vgs-missing-pvs-2.02.02.txt \
1140         test/data/vgs-missing-pvs-2.02.66.txt \
1141         test/data/xen-xm-info-4.0.1.txt \
1142         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1143         test/data/xen-xm-list-4.0.1-four-instances.txt \
1144         test/data/xen-xm-list-long-4.0.1.txt \
1145         test/data/xen-xm-uptime-4.0.1.txt \
1146         test/py/ganeti-cli.test \
1147         test/py/gnt-cli.test \
1148         test/py/import-export_unittest-helper
1149
1150
1151 python_tests = \
1152         doc/examples/rapi_testutils.py \
1153         test/py/cfgupgrade_unittest.py \
1154         test/py/docs_unittest.py \
1155         test/py/ganeti.asyncnotifier_unittest.py \
1156         test/py/ganeti.backend_unittest-runasroot.py \
1157         test/py/ganeti.backend_unittest.py \
1158         test/py/ganeti.bdev_unittest.py \
1159         test/py/ganeti.cli_unittest.py \
1160         test/py/ganeti.client.gnt_cluster_unittest.py \
1161         test/py/ganeti.client.gnt_instance_unittest.py \
1162         test/py/ganeti.client.gnt_job_unittest.py \
1163         test/py/ganeti.cmdlib_unittest.py \
1164         test/py/ganeti.compat_unittest.py \
1165         test/py/ganeti.confd.client_unittest.py \
1166         test/py/ganeti.config_unittest.py \
1167         test/py/ganeti.constants_unittest.py \
1168         test/py/ganeti.daemon_unittest.py \
1169         test/py/ganeti.errors_unittest.py \
1170         test/py/ganeti.hooks_unittest.py \
1171         test/py/ganeti.ht_unittest.py \
1172         test/py/ganeti.http_unittest.py \
1173         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1174         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1175         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1176         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1177         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1178         test/py/ganeti.hypervisor_unittest.py \
1179         test/py/ganeti.impexpd_unittest.py \
1180         test/py/ganeti.jqueue_unittest.py \
1181         test/py/ganeti.jstore_unittest.py \
1182         test/py/ganeti.locking_unittest.py \
1183         test/py/ganeti.luxi_unittest.py \
1184         test/py/ganeti.masterd.iallocator_unittest.py \
1185         test/py/ganeti.masterd.instance_unittest.py \
1186         test/py/ganeti.mcpu_unittest.py \
1187         test/py/ganeti.netutils_unittest.py \
1188         test/py/ganeti.objects_unittest.py \
1189         test/py/ganeti.opcodes_unittest.py \
1190         test/py/ganeti.outils_unittest.py \
1191         test/py/ganeti.ovf_unittest.py \
1192         test/py/ganeti.qlang_unittest.py \
1193         test/py/ganeti.query_unittest.py \
1194         test/py/ganeti.rapi.baserlib_unittest.py \
1195         test/py/ganeti.rapi.client_unittest.py \
1196         test/py/ganeti.rapi.resources_unittest.py \
1197         test/py/ganeti.rapi.rlib2_unittest.py \
1198         test/py/ganeti.rapi.testutils_unittest.py \
1199         test/py/ganeti.rpc_unittest.py \
1200         test/py/ganeti.runtime_unittest.py \
1201         test/py/ganeti.serializer_unittest.py \
1202         test/py/ganeti.server.rapi_unittest.py \
1203         test/py/ganeti.ssconf_unittest.py \
1204         test/py/ganeti.ssh_unittest.py \
1205         test/py/ganeti.storage_unittest.py \
1206         test/py/ganeti.tools.burnin_unittest.py \
1207         test/py/ganeti.tools.ensure_dirs_unittest.py \
1208         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1209         test/py/ganeti.tools.prepare_node_join_unittest.py \
1210         test/py/ganeti.uidpool_unittest.py \
1211         test/py/ganeti.utils.algo_unittest.py \
1212         test/py/ganeti.utils.filelock_unittest.py \
1213         test/py/ganeti.utils.hash_unittest.py \
1214         test/py/ganeti.utils.io_unittest-runasroot.py \
1215         test/py/ganeti.utils.io_unittest.py \
1216         test/py/ganeti.utils.log_unittest.py \
1217         test/py/ganeti.utils.lvm_unittest.py \
1218         test/py/ganeti.utils.mlock_unittest.py \
1219         test/py/ganeti.utils.nodesetup_unittest.py \
1220         test/py/ganeti.utils.process_unittest.py \
1221         test/py/ganeti.utils.retry_unittest.py \
1222         test/py/ganeti.utils.text_unittest.py \
1223         test/py/ganeti.utils.wrapper_unittest.py \
1224         test/py/ganeti.utils.x509_unittest.py \
1225         test/py/ganeti.utils_unittest.py \
1226         test/py/ganeti.vcluster_unittest.py \
1227         test/py/ganeti.workerpool_unittest.py \
1228         test/py/pycurl_reset_unittest.py \
1229         test/py/qa.qa_config_unittest.py \
1230         test/py/tempfile_fork_unittest.py
1231
1232 haskell_tests = test/hs/htest
1233
1234 dist_TESTS = \
1235         test/py/check-cert-expired_unittest.bash \
1236         test/py/daemon-util_unittest.bash \
1237         test/py/ganeti-cleaner_unittest.bash \
1238         test/py/import-export_unittest.bash \
1239         test/py/cli-test.bash \
1240         test/py/bash_completion.bash
1241
1242 if !PY_NODEV
1243         dist_TESTS += $(python_tests)
1244 endif
1245
1246 nodist_TESTS =
1247 check_SCRIPTS =
1248
1249 if WANT_HSTESTS
1250 nodist_TESTS += $(haskell_tests)
1251 dist_TESTS += test/hs/offline-test.sh
1252 check_SCRIPTS += \
1253         test/hs/hpc-htools \
1254         test/hs/hpc-mon-collector \
1255         $(HS_BUILT_TEST_HELPERS)
1256 endif
1257
1258 TESTS = $(dist_TESTS) $(nodist_TESTS)
1259
1260 # Environment for all tests
1261 PLAIN_TESTS_ENVIRONMENT = \
1262         PYTHONPATH=. \
1263         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1264         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1265         $(RUN_IN_TEMPDIR)
1266
1267 # Environment for tests run by automake
1268 TESTS_ENVIRONMENT = \
1269         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1270
1271 all_python_code = \
1272         $(dist_sbin_SCRIPTS) \
1273         $(python_scripts) \
1274         $(pkglib_python_scripts) \
1275         $(nodist_pkglib_python_scripts) \
1276         $(nodist_tools_python_scripts) \
1277         $(pkgpython_PYTHON) \
1278         $(client_PYTHON) \
1279         $(cmdlib_PYTHON) \
1280         $(hypervisor_PYTHON) \
1281         $(rapi_PYTHON) \
1282         $(server_PYTHON) \
1283         $(pytools_PYTHON) \
1284         $(http_PYTHON) \
1285         $(confd_PYTHON) \
1286         $(masterd_PYTHON) \
1287         $(impexpd_PYTHON) \
1288         $(utils_PYTHON) \
1289         $(watcher_PYTHON) \
1290         $(noinst_PYTHON) \
1291         $(qa_scripts)
1292
1293 if !PY_NODEV
1294         all_python_code += $(python_tests)
1295 endif
1296
1297 srclink_files = \
1298         man/footer.rst \
1299         test/py/check-cert-expired_unittest.bash \
1300         test/py/daemon-util_unittest.bash \
1301         test/py/ganeti-cleaner_unittest.bash \
1302         test/py/import-export_unittest.bash \
1303         test/py/cli-test.bash \
1304         test/py/bash_completion.bash \
1305         test/hs/offline-test.sh \
1306         test/hs/cli-tests-defs.sh \
1307         $(all_python_code) \
1308         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1309         $(docinput)
1310
1311 check_python_code = \
1312         $(BUILD_BASH_COMPLETION) \
1313         $(CHECK_IMPORTS) \
1314         $(CHECK_HEADER) \
1315         $(DOCPP) \
1316         $(all_python_code)
1317
1318 lint_python_code = \
1319         ganeti \
1320         ganeti/http/server.py \
1321         $(dist_sbin_SCRIPTS) \
1322         $(python_scripts) \
1323         $(pkglib_python_scripts) \
1324         $(BUILD_BASH_COMPLETION) \
1325         $(CHECK_IMPORTS) \
1326         $(CHECK_HEADER) \
1327         $(DOCPP) \
1328         $(PYTHON_BOOTSTRAP)
1329
1330 standalone_python_modules = \
1331         lib/rapi/client.py \
1332         tools/ganeti-listrunner
1333
1334 pep8_python_code = \
1335         ganeti \
1336         ganeti/http/server.py \
1337         $(dist_sbin_SCRIPTS) \
1338         $(python_scripts) \
1339         $(pkglib_python_scripts) \
1340         $(BUILD_BASH_COMPLETION) \
1341         $(CHECK_HEADER) \
1342         $(DOCPP) \
1343         $(PYTHON_BOOTSTRAP) \
1344         qa
1345
1346 test/py/daemon-util_unittest.bash: daemons/daemon-util
1347
1348 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1349
1350 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1351
1352 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1353         sed -f $(REPLACE_VARS_SED) < $< > $@
1354         chmod +x $@
1355
1356 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1357         sed -f $(REPLACE_VARS_SED) < $< > $@
1358         chmod +x $@
1359
1360 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1361         sed -f $(REPLACE_VARS_SED) < $< > $@
1362         chmod +x $@
1363
1364 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1365         sed -f $(REPLACE_VARS_SED) < $< > $@
1366         chmod +x $@
1367
1368 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1369         sed -f $(REPLACE_VARS_SED) < $< > $@
1370
1371 doc/examples/bash_completion: BC_ARGS = --compact
1372 doc/examples/bash_completion-debug: BC_ARGS =
1373
1374 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1375         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1376         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1377         daemons/ganeti-cleaner \
1378         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1379         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1380           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1381
1382 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1383         lib/build/shell_example_lexer.py \
1384         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1385         @echo "Checking $< for hardcoded paths..."
1386         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1387           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1388           exit 1; \
1389         fi
1390         set -e ; \
1391         trap 'echo auto-removing $@; rm $@' EXIT; \
1392         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1393         $(CHECK_MAN_REFERENCES) $@; \
1394         trap - EXIT
1395
1396 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1397         @test -n "$(PANDOC)" || \
1398           { echo 'pandoc' not found during configure; exit 1; }
1399         set -o pipefail -e; \
1400         trap 'echo auto-removing $@; rm $@' EXIT; \
1401         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1402           sed -e 's/\\@/@/g' > $@; \
1403         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1404         $(CHECK_MAN_DASHES) $@; \
1405         trap - EXIT
1406
1407 man/%.html.in: man/%.gen man/footer.rst
1408         @test -n "$(PANDOC)" || \
1409           { echo 'pandoc' not found during configure; exit 1; }
1410         set -o pipefail ; \
1411         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1412           sed -e 's/\\@/@/g' > $@
1413
1414 man/%: man/%.in  $(REPLACE_VARS_SED)
1415         sed -f $(REPLACE_VARS_SED) < $< > $@
1416
1417 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1418         sed -f $(REPLACE_VARS_SED) < $< > $@
1419
1420 vcs-version:
1421         if test -d .git; then \
1422           git describe > $@; \
1423         elif test ! -f $@ ; then \
1424           echo "Cannot auto-generate $@ file"; exit 1; \
1425         fi
1426
1427 .PHONY: clean-vcs-version
1428 clean-vcs-version:
1429         rm -f vcs-version
1430
1431 .PHONY: regen-vcs-version
1432 regen-vcs-version:
1433         @set -e; \
1434         cd $(srcdir); \
1435         if test -d .git; then \
1436           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1437           git describe > $$T; \
1438           if ! cmp --quiet $$T vcs-version; then \
1439             mv $$T vcs-version; \
1440           fi; \
1441         fi
1442
1443 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1444         vcs-version $(built_base_sources)
1445         set -e; \
1446         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1447         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1448
1449 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1450         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1451         lib/jstore.py $(RUN_IN_TEMPDIR) \
1452         $(CONVERT_CONSTANTS) $(built_base_sources) \
1453         | lib/_vcsversion.py
1454         set -e; \
1455         { cat $< ; \
1456           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1457         } > $@
1458
1459 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1460         hsc2hs -o $@ $<
1461
1462 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1463         $(built_base_sources)
1464         set -e; \
1465         { cat $< ; \
1466           echo ; \
1467           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1468             echo "import $$name ()" ; \
1469           done ; \
1470         } > $@
1471
1472 lib/_autoconf.py: Makefile | stamp-directories
1473         set -e; \
1474         { echo '# This file is automatically generated, do not edit!'; \
1475           echo '#'; \
1476           echo ''; \
1477           echo '"""Build-time configuration for Ganeti.'; \
1478           echo '';\
1479           echo 'This file is autogenerated by the build process.'; \
1480           echo 'For any changes you need to re-run ./configure (and'; \
1481           echo 'not edit by hand).'; \
1482           echo ''; \
1483           echo '"""'; \
1484           echo ''; \
1485           echo '# pylint: disable=C0301,C0324'; \
1486           echo '# because this is autogenerated, we do not want'; \
1487           echo '# style warnings' ; \
1488           echo ''; \
1489           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1490           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1491           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1492           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1493           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1494           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1495           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1496           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1497           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1498           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1499           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1500           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1501           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1502           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1503           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1504           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1505           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1506           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1507           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1508           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1509           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1510           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1511           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1512           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1513           echo "KVM_PATH = '$(KVM_PATH)'"; \
1514           echo "IP_PATH = '$(IP_PATH)'"; \
1515           echo "SOCAT_PATH = '$(SOCAT)'"; \
1516           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1517           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1518           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1519           echo "TOOLSDIR = '$(toolsdir)'"; \
1520           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1521           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1522           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1523           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1524           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1525           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1526           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1527           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1528           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1529           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1530           echo "RAPI_USER = '$(RAPI_USER)'"; \
1531           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1532           echo "CONFD_USER = '$(CONFD_USER)'"; \
1533           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1534           echo "NODED_USER = '$(NODED_USER)'"; \
1535           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1536           echo "MOND_USER = '$(MOND_USER)'"; \
1537           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1538           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1539           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1540           echo "HTOOLS = True"; \
1541           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1542           echo "XEN_CMD = '$(XEN_CMD)'"; \
1543           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1544           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1545           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1546 ## Write dictionary with man page name as the key and the section number as the
1547 ## value
1548           echo "MAN_PAGES = {"; \
1549           for i in $(notdir $(man_MANS)); do \
1550             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1551           done; \
1552           echo "}"; \
1553         } > $@
1554
1555 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1556         set -e; \
1557         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1558         { echo '# This file is automatically generated, do not edit!'; \
1559           echo '#'; \
1560           echo ''; \
1561           echo '"""Build-time VCS version number for Ganeti.'; \
1562           echo '';\
1563           echo 'This file is autogenerated by the build process.'; \
1564           echo 'For any changes you need to re-run ./configure (and'; \
1565           echo 'not edit by hand).'; \
1566           echo ''; \
1567           echo '"""'; \
1568           echo ''; \
1569           echo '# pylint: disable=C0301,C0324'; \
1570           echo '# because this is autogenerated, we do not want'; \
1571           echo '# style warnings' ; \
1572           echo ''; \
1573           echo "VCS_VERSION = '$$VCSVER'"; \
1574         } > $@
1575
1576 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1577         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1578
1579 $(SHELL_ENV_INIT): Makefile stamp-directories
1580         set -e; \
1581         { echo '# Allow overriding for tests'; \
1582           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1583           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1584           echo; \
1585           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1586           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1587           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1588           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1589           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1590         } > $@
1591
1592 ## Writes sed script to replace placeholders with build-time values. The
1593 ## additional quotes after the first @ sign are necessary to stop configure
1594 ## from replacing those values as well.
1595 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1596         set -e; \
1597         { echo 's#@''PREFIX@#$(prefix)#g'; \
1598           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1599           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1600           echo 's#@''BINDIR@#$(bindir)#g'; \
1601           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1602           echo 's#@''LIBDIR@#$(libdir)#g'; \
1603           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1604           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1605           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1606           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1607           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1608           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1609           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1610           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1611           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1612           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1613           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1614           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1615           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1616           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1617           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1618           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1619           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1620           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1621           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1622           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1623           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1624           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1625           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1626           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1627           echo; \
1628           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1629           echo '  r $(SHELL_ENV_INIT)'; \
1630           echo '  d'; \
1631           echo '}'; \
1632         } > $@
1633
1634 # Using deferred evaluation
1635 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1636 daemons/ganeti-watcher: MODULE = ganeti.watcher
1637 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1638 tools/burnin: MODULE = ganeti.tools.burnin
1639 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1640 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1641 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1642 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1643 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1644
1645 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1646         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1647         set -e; \
1648         { echo '#!/usr/bin/python'; \
1649           echo '# This file is automatically generated, do not edit!'; \
1650           echo "# Edit $(MODULE) instead."; \
1651           echo; \
1652           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1653           echo; \
1654           echo '# pylint: disable=C0103'; \
1655           echo '# C0103: Invalid name'; \
1656           echo; \
1657           echo 'import sys'; \
1658           echo 'import $(MODULE) as main'; \
1659           echo; \
1660           echo '# Temporarily alias commands until bash completion'; \
1661           echo '# generator is changed'; \
1662           echo 'if hasattr(main, "commands"):'; \
1663           echo '  commands = main.commands # pylint: disable=E1101'; \
1664           echo 'if hasattr(main, "aliases"):'; \
1665           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1666           echo; \
1667           echo 'if __name__ == "__main__":'; \
1668           echo '  sys.exit(main.Main())'; \
1669         } > $@
1670         chmod u+x $@
1671
1672 $(HS_BUILT_TEST_HELPERS): Makefile
1673         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1674         set -e; \
1675         { echo '#!/bin/sh'; \
1676           echo '# This file is automatically generated, do not edit!'; \
1677           echo "# Edit Makefile.am instead."; \
1678           echo; \
1679           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1680         } > $@
1681         chmod u+x $@
1682
1683 stamp-directories: Makefile
1684         $(MAKE) $(AM_MAKEFLAGS) ganeti
1685         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1686         touch $@
1687
1688 # We need to create symlinks because "make distcheck" will not install Python
1689 # files when building.
1690 stamp-srclinks: Makefile | stamp-directories
1691         set -e; \
1692         for i in $(srclink_files); do \
1693           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1694             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1695           fi; \
1696         done
1697         touch $@
1698
1699 .PHONY: ganeti
1700 ganeti:
1701         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1702
1703 .PHONY: check-dirs
1704 check-dirs: $(GENERATED_FILES)
1705         @set -e; \
1706         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1707           error=; \
1708           while read dir; do \
1709             case "$$dir" in \
1710               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1711               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1712             esac; \
1713           done; \
1714           for dir in $(DIRS); do \
1715             if ! test -d "$$dir"; then \
1716               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1717               error=1; \
1718             fi \
1719           done; \
1720           test -z "$$error"; \
1721         }
1722
1723 .PHONY: check-local
1724 check-local: check-dirs $(GENERATED_FILES)
1725         $(CHECK_PYTHON_CODE) $(check_python_code)
1726         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1727         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1728         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1729         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1730         error= ; \
1731         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1732           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1733           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1734             echo "Incorrect version in README, expected $$expver" >&2; \
1735             error=1; \
1736           fi; \
1737           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1738               doc/security.rst; do \
1739             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1740               "Documents Ganeti version $$expver"; then \
1741               echo "Incorrect version in $$file, expected $$expver" >&2; \
1742               error=1; \
1743             fi; \
1744           done; \
1745           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1746             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1747             error=1; \
1748           fi; \
1749           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1750             ".. Last updated for Ganeti $$expver"; then \
1751             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1752             error=1; \
1753           fi; \
1754         fi; \
1755         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1756           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1757             echo "Longest line in $$file is longer than 80 characters" >&2; \
1758             error=1; \
1759           fi; \
1760         done; \
1761         test -z "$$error"
1762
1763 .PHONY: hs-tests
1764 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1765         @rm -f htest.tix
1766         ./test/hs/htest
1767
1768 .PHONY: hs-shell
1769 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1770         @rm -f hpc-htools.tix hpc-mon-collector.tix
1771         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1772
1773 .PHONY: hs-check
1774 hs-check: hs-tests hs-shell
1775
1776 # E111: indentation is not a multiple of four
1777 # E121: continuation line indentation is not a multiple of four
1778 #       (since our indent level is not 4)
1779 # E125: continuation line does not distinguish itself from next logical line
1780 #       (since our indent level is not 4)
1781 # E127: continuation line over-indented for visual indent
1782 #       (since our indent level is not 4)
1783 # note: do NOT add E128 here; it's a valid style error in most cases!
1784 # I've seen real errors, but also some cases were we indent wrongly
1785 # due to line length; try to rework the cases where it is triggered,
1786 # instead of silencing it
1787 # E261: at least two spaces before inline comment
1788 # E501: line too long (80 characters)
1789 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1790
1791 # For excluding pep8 expects filenames only, not whole paths
1792 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1793
1794 LINT_TARGETS = pylint pylint-qa
1795 if HAS_PEP8
1796 LINT_TARGETS += pep8
1797 endif
1798 if HAS_HLINT
1799 LINT_TARGETS += hlint
1800 endif
1801
1802 .PHONY: lint
1803 lint: $(LINT_TARGETS)
1804
1805 .PHONY: pylint
1806 pylint: $(GENERATED_FILES)
1807         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1808         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1809
1810 .PHONY: pylint-qa
1811 pylint-qa: $(GENERATED_FILES)
1812         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1813         cd $(top_srcdir)/qa && \
1814           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1815           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1816
1817 .PHONY: pep8
1818 pep8: $(GENERATED_FILES)
1819         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1820         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1821           --repeat $(pep8_python_code)
1822
1823 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1824 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1825 .PHONY: hlint
1826 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1827         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1828         @rm -f doc/hs-lint.html
1829         if tty -s; then C="-c"; else C=""; fi; \
1830         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1831           --ignore "Use first" \
1832           --ignore "Use &&&" \
1833           --ignore "Use void" \
1834           --ignore "Reduce duplication" \
1835           --hint src/lint-hints \
1836           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1837         @if [ ! -f doc/hs-lint.html ]; then \
1838           echo "All good" > doc/hs-lint.html; \
1839         fi
1840
1841 # a dist hook rule for updating the vcs-version file; this is
1842 # hardcoded due to where it needs to build the file...
1843 dist-hook:
1844         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1845         rm -f $(top_distdir)/vcs-version
1846         cp -p $(srcdir)/vcs-version $(top_distdir)
1847
1848 # a distcheck hook rule for catching revision control directories
1849 distcheck-hook:
1850         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1851           echo "Found revision control files in final archive." 1>&2; \
1852           exit 1; \
1853         fi
1854         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1855           echo "Found Python byte code in final archive." 1>&2; \
1856           exit 1; \
1857         fi
1858         if find $(top_distdir) -name '*~' | grep .; then \
1859           echo "Found backup files in final archive." 1>&2; \
1860           exit 1; \
1861         fi
1862 # Empty files or directories should not be distributed. They can cause
1863 # unnecessary warnings for packagers. Directories used by automake during
1864 # distcheck must be excluded.
1865         if find $(top_distdir) -empty -and -not \( \
1866             -path $(top_distdir)/_build -or \
1867             -path $(top_distdir)/_inst \) | grep .; then \
1868           echo "Found empty files or directories in final archive." 1>&2; \
1869           exit 1; \
1870         fi
1871         if test -e $(top_distdir)/doc/man-html; then \
1872           echo "Found documentation including man pages in final archive" >&2; \
1873           exit 1; \
1874         fi
1875
1876 # Backwards compatible distcheck-release target
1877 distcheck-release: distcheck
1878
1879 distrebuildcheck: dist
1880         set -e; \
1881         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1882         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1883         cd $$builddir; \
1884         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1885         cd $(distdir); \
1886         ./configure; \
1887         $(MAKE) maintainer-clean; \
1888         cp $(abs_srcdir)/vcs-version .; \
1889         ./configure; \
1890         $(MAKE) $(AM_MAKEFLAGS)
1891
1892 dist-release: dist
1893         set -e; \
1894         for i in $(DIST_ARCHIVES); do \
1895           echo -n "Checking $$i ... "; \
1896           autotools/check-tar < $$i; \
1897           echo OK; \
1898         done
1899
1900 install-exec-local:
1901         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1902           "$(DESTDIR)${localstatedir}/log/ganeti" \
1903           "$(DESTDIR)${localstatedir}/run/ganeti"
1904
1905 .PHONY: apidoc
1906 if WANT_HSAPIDOC
1907 apidoc: py-apidoc hs-apidoc
1908 else
1909 apidoc: py-apidoc
1910 endif
1911
1912 .PHONY: py-apidoc
1913 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1914         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1915         $(RUN_IN_TEMPDIR) epydoc -v \
1916           --conf $(CURDIR)/epydoc.conf \
1917           --output $(CURDIR)/$(APIDOC_PY_DIR)
1918
1919 .PHONY: hs-apidoc
1920 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1921
1922 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1923         @test -n "$(HSCOLOUR)" || \
1924             { echo 'HsColour' not found during configure; exit 1; }
1925         @test -n "$(HADDOCK)" || \
1926             { echo 'haddock' not found during configure; exit 1; }
1927         rm -rf $(APIDOC_HS_DIR)/*
1928         for i in $(ALL_APIDOC_HS_DIRS); do \
1929           @mkdir_p@ $$i; \
1930           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1931         done
1932         set -e ; \
1933         export LC_ALL=en_US.UTF-8; \
1934         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1935         if [ "$(HS_PARALLEL3)" ]; \
1936         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1937         fi; \
1938         if [ "$(HS_REGEX_PCRE)" ]; \
1939         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1940         fi; \
1941         for file in $(HS_LIBTESTBUILT_SRCS); do \
1942           f_nosrc=$${file##src/}; \
1943           f_notst=$${f_nosrc##test/hs/}; \
1944           f_html=$${f_notst%%.hs}.html; \
1945           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1946         done ; \
1947         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1948           -t ganeti -p src/haddock-prologue \
1949           --source-module="%{MODULE/.//}.html" \
1950           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1951           $$OPTGHC \
1952           $(HS_LIBTESTBUILT_SRCS)
1953
1954 .PHONY: TAGS
1955 TAGS: $(GENERATED_FILES)
1956         rm -f TAGS
1957         $(GHC) -e ":etags" -v0 \
1958           $(filter-out -O -Werror,$(HFLAGS)) \
1959           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1960           $(HS_LIBTEST_SRCS)
1961         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1962           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1963           -path './qa/*.py' | \
1964           etags -l python -a -
1965
1966 .PHONY: coverage
1967
1968 COVERAGE_TESTS=
1969 if WANT_HTOOLS
1970 COVERAGE_TESTS += hs-coverage
1971 endif
1972 if !PY_NODEV
1973 COVERAGE_TESTS += py-coverage
1974 endif
1975
1976 coverage: $(COVERAGE_TESTS)
1977
1978 .PHONY: py-coverage
1979 py-coverage: $(GENERATED_FILES) $(python_tests)
1980         @test -n "$(PYCOVERAGE)" || \
1981             { echo 'python-coverage' not found during configure; exit 1; }
1982         set -e; \
1983         COVERAGE=$(PYCOVERAGE) \
1984         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1985         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1986         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1987         $(PLAIN_TESTS_ENVIRONMENT) \
1988         $(abs_top_srcdir)/autotools/gen-py-coverage \
1989         $(python_tests)
1990
1991 .PHONY: hs-coverage
1992 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1993         rm -f *.tix
1994         $(MAKE) $(AM_MAKEFLAGS) hs-check
1995         @mkdir_p@ $(COVERAGE_HS_DIR)
1996         hpc sum --union $(HPCEXCL) \
1997           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1998         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1999         hpc report coverage-hs.tix
2000         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2001
2002 # Special "kind-of-QA" target for htools, needs special setup (all
2003 # tools compiled with -fhpc)
2004 .PHONY: live-test
2005 live-test: all
2006         set -e ; \
2007         cd src; \
2008         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2009         rm -f *.tix *.mix; \
2010         ./live-test.sh; \
2011         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2012           --output=live-test.tix ; \
2013         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2014         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2015           --srcdir=.. $(HPCEXCL) ; \
2016         hpc report --srcdir=.. live-test $(HPCEXCL)
2017
2018 commit-check: autotools-check distcheck lint apidoc
2019
2020 autotools-check:
2021         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2022   $(abs_top_srcdir)/test/autotools/*-*.test \
2023   -- --hide-successes
2024
2025 .PHONY: gitignore-check
2026 gitignore-check:
2027         @if [ -n "`git status --short`" ]; then \
2028           echo "Git status is not clean!" 1>&2 ; \
2029           git status --short; \
2030           exit 1; \
2031         fi
2032
2033 # target to rebuild all man pages (both groff and html output)
2034 .PHONY: man
2035 man: $(man_MANS) $(manhtml)
2036
2037 # Target that builds all binaries (including those that are not
2038 # rebuilt except when running the tests)
2039 .PHONY: really-all
2040 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2041
2042 # we don't need the ancient implicit rules:
2043 %: %,v
2044 %: RCS/%,v
2045 %: RCS/%
2046 %: s.%
2047 %: SCCS/s.%
2048
2049 -include ./Makefile.local
2050
2051 # vim: set noet :